<template>
  <div class="echart" ref="chart"></div>
</template>

<script>
import * as echarts from "echarts"

export default {
  data() {
    return {}
  },
  mounted() {
    this.initChart()
  },
  methods: {
    initChart() {
      const chart = echarts.init(this.$refs.chart)

      chart.setOption(option)
      window.addEventListener("resize", function () {
        chart.resize()
      })
    },
    initData() {
      let dataPie = [
        {
          value: 410,
          name: "企业",
        },
        {
          value: 380,
          name: "政府",
        },
        {
          value: 50,
          name: "个人",
        },
        {
          value: 50,
          name: "个人1",
        },
        {
          value: 50,
          name: "个人2",
        },
        {
          value: 50,
          name: "个人3",
        },
        {
          value: 50,
          name: "个人4",
        },
        {
          value: 50,
          name: "个人5",
        },
      ]
      let colorPie = ["#5f6d86", "#0b2036", "#002e49"]
      let colorWrap = [
        "#3087d6",
        "#afe1ff",
        "#4be1ff",
        "#006CFF",
        "#5C7AAE",
        "#15D0FF",
        "#00BAFF",
        "#9BD3FF",
      ]
      let baseDataPie = [],
        baseDataWrap = []
      for (var i = 0; i < dataPie.length; i++) {
        baseDataPie.push({
          value: dataPie[i].value,
          name: dataPie[i].name,
          itemStyle: {
            normal: {
              borderWidth: 0.5,
              borderColor: "#5f6d86",
            },
          },
        })
        baseDataWrap.push(
          {
            value: dataPie[i].value,
            name: dataPie[i].name,
            itemStyle: {
              normal: {
                color: colorWrap[i],
                borderWidth: 5,
                borderColor: colorWrap[i],
                shadowBlur: 5,
                shadowColor: "rgba(48, 135, 214, 0.3)",
              },
            },
          },
          {
            value: 30,
            name: "",
            itemStyle: {
              normal: {
                color: "transparent",
                borderWidth: 20,
                borderColor: "transparent",
              },
            },
          }
        )
      }

      let option = {
        backgroundColor: "#021228",
        title: {
          text: "服务类型总数量",
          subtext: "10,225",
          textStyle: {
            color: "#00b5f3",
            fontSize: 12,
          },
          subtextStyle: {
            align: "center",
            fontSize: 18,
            color: ["#85c7e3"],
            fontWeight: 800,
          },
          x: "20%",
          y: "40%",
        },
        tooltip: {
          show: true,
          // trigger: "item",
          // formatter: "{a}：{b} <br/>占比：{d}%",
        },
        legend: {
          data: ["企业", "政府", "个人"],
          icon: "vertical",
          right: "1%",
          top: "center",
          orient: "vertical",
          itemGap: 20,
          itemWidth: 12,
          itemHeight: 3,

          formatter: function (name) {
            let target
            for (let i = 0; i < dataPie.length; i++) {
              if (dataPie[i].name === name) {
                target = dataPie[i].value
              }
            }
            let arr = [name, target]
            return arr.join("\n")
          },
          textStyle: {
            lineHeight: 20,
            color: "#9ed2f5",
          },
        },
        grid: {
          left: "1%", // 与容器左侧的距离
          right: "1%", // 与容器右侧的距离
          top: "1%", // 与容器顶部的距离
          bottom: "1%", // 与容器底部的距离
        },
        series: [
          {
            name: "",
            type: "pie",
            clockWise: false, //顺时加载
            hoverAnimation: false, //鼠标移入变大
            center: ["30%", "50%"],
            radius: ["60%", "65%"],
            tooltip: {
              show: false,
            },
            label: {
              normal: {
                show: false,
              },
            },
            data: baseDataWrap,
          },
          {
            name: "报警",
            type: "pie",
            color: "#5F6D86",
            selectedMode: "single",
            center: ["30%", "50%"],
            radius: ["73%", "74%"],
            hoverAnimation: false,
            label: {
              normal: {
                show: false,
              },
            },

            data: baseDataPie,
          },
        ],
      }
    },
  },
}
</script>

<style lang="scss" scoped>
.echart {
  width: 100%;
  height: 100%;
}
</style>
